' First we have to include the routines to the procect. That easily happens by either including the code file
' itself, or including the library via its definitions file:

'#Include "ManageMenu.bas"             ' this would include the whole code
#Include "ManageMenu.bi"               ' this will include the library.
' both lines will have the same effect. Choose the one, that is more sympathic to you ;)

' Some example subs.
Declare Sub s1
Declare Sub s2
Declare Sub s3
Declare Sub s0

' The scope is only for testing the Destructor.
Scope
   ' We're going to use these vars:
   Dim As TreeType     l01                   ' Container of the base-level (Lvl 1)
                                             '  By declaring this variable, our tree structure is initialized.
   Dim As TreeType Ptr l02, l03, l04         ' Pointers to containers of Levels 2 to 4.
                                             '  We're using pointers, as these are not affected by a DTor.
   Dim As TreeElementType NLT                ' A temporary UDT, used to create new elements in the tree.
   Dim As OutStruct outArray()               ' Herein, we'll save our tree-Structur in Flat-Design
   Dim As StructElementDescriptor tmpDesc    ' This will be used to get data about some Element in tree, we'll
                                             '  want to analyze after it was created
   Dim As String s                           ' An string, used for several things...
   Dim As Integer i, j, k, l                 ' FOR...NEXT-Counters
   
   
   s = "Test1"                         ' this will be the caption
   With NLT                            ' within this UDT, any Data is prepared for the new tree Element
      .caption  = StrPtr(         s)   ' Any Data that should be used in the tree are prepared as pointers
      .Procedur = Cast(Any Ptr, @s1)   ' You could call this procedure, when this Menu-Element was activated
      .reduced  = 0                    ' These are flags. They're used when showing the struct.
      .disabled = 0
      .Misc     = 0                    ' Here, you could add some userdefined information in any format.
   End With
   l01.AddItem NLT                     ' And now, simply add the Information. Ok, it's done!
   
   ' We'll repeat the game, and create some other Menu elements.
   s = "Test2"                         ' AddItem copies the string to memory, so we're able to change the value of 's'
   With NLT
      .caption  = StrPtr(         s)
      .Procedur = Cast(Any Ptr, @s2)
      .reduced  = 0
   End With
   l01.AddItem NLT                     ' New items are added at the beginning of a tree - index zero.

   s = "Deleteme"
   With NLT
      .caption  = StrPtr(         s)
      .Procedur = Cast(Any Ptr, @s1)
      .reduced  = 0
   End With
   l01.AddItem NLT

   s = "Test3"
   With NLT
      .caption  = StrPtr(         s)
      .Procedur = Cast(Any Ptr, @s3)
      .reduced  = 0
   End With
   l01.AddItem NLT, 3      ' now, let's say, this has to be at position 4. Just add the index! (indices are
                           '  beginning at zero!)


   l01.DelItem             ' let's delete the last Item from the tree. If you want to del any other element but
                           '  the last one, add an index to the syntax, just as we did with AddItem!


   ' The names, we've used aren't very nice, are they? Let's change 'em!
   l01.caption(0) = "Test 0"
   l01.caption(1) = "Test 1"
   l01.caption(2) = "Test 2"
   l01.caption(3) = "Test 3"

   ' It's time to create some elements on Child-Level!
   For i = 0 To 3

      ' Now, there should be one child-Level for every top-level-element!
      l02 = l01.CreateChildLevel(i)
      For j = 0 To 3
         s = l01.caption(i) & "." & j     ' prepare a string, holding the name of the sub-element
         With NLT                         ' prepare the data for the sub-element
            .caption  = StrPtr(         s)
            .Procedur = Cast(Any Ptr, @s0)
         End With
         l02->AddItem NLT, j              ' and create the element, using an index.


         ' now, why should we create only one child-level, if we're able to produce a second one?
         l03 = l02->CreateChildLevel(j)
         For k = 0 To 3
            s = l02->caption(j) & "." & k
            With NLT
               .caption  = StrPtr(         s)
               .Procedur = Cast(Any Ptr, @s0)
            End With
            l03->AddItem NLT, k


            ' well, the saying goes something like "all good things are three", so let's have a third
            '  child-level!
            l04 = l03->CreateChildLevel(k)
            For l = 0 To 3
               s = l03->caption(k) & "." & l
               With NLT
                  .caption  = StrPtr(         s)
                  .Procedur = Cast(Any Ptr, @s0)
               End With
               l04->AddItem NLT, l
               
               
            Next l
         Next k         
      Next j
   Next i
   ' now, by this, we've created a tree structure, that has four elements on every level.
   ' There are four levels.
   ' You see, there are:
   ' 3 Top-Level-Items              3
   ' 3 * 4 Level2-Items            12
   ' 3 * 4 * 4 Level3-Items        48
   ' 3 * 4 * 4 * 4 Level4-Items   192
   ' that leads to...             255 Elements!
   
   ' Well... maybe, there's no need for the Childs of the second element on top-level... delete them!
   l01.DeleteChildLevel(0)

   ' now, the reduced-flag:
   l02 = l01.Child(1)      ' first find the adress of the child of the second branch on top-level
   l02->Reduced(0) = 1     '  and let every child of them be reduced.
   l02->Reduced(1) = 1     '  now, they still exist, but the childs aren't shown any more.
   l02->Reduced(2) = 1
   l02->Reduced(3) = 1
   
   ' what about the disabled-flag?
   l02 = l01. Child(2)     ' again, find the adress...
   l03 = l02->Child(3)
   l04 = l03->Child(3)
   l04->Disabled(0) = 1    '  and disable the elements
   l04->Disabled(1) = 1    '  they still exist, and any one of them will be shown, but...
   l04->Disabled(2) = 1    '  they'll just be marked as disabled!
   l04->Disabled(3) = 1

   ' now, we want to show, what we've created.
   ' so, we'll have to get the data from the tree structure in a flat array:
   Struct2Array @l01, outArray()    ' Tell me, where to take the data from, and you'll get what you want!
   
   ' and now, simply output the data using Print Using:
   For i = 0 To UBound(outArray)
      Color IIf( outArray(i).disabled, 2, 10 )     ' use bright colours for activated, low colours for 
                                                   '  disabled items.
      ? Using "###&"; i ; ") " & Space( outArray(i).level ) & outArray(i).caption
   Next
   Color 15
   ?
   
   i = 5
   ? "Trying to Find Element #" & i
   tmpDesc = FindElmByIdx( @l01, i )
   ? " caption of Element #" & i & " :"
   ? "  " & tmpDesc.Group->Caption( tmpDesc.idx )
   ?
End Scope

? "Example done."
GetKey


Sub s1
   ? "Proc of Element 0"
End Sub

Sub s2
   ? "Proc of Element 1"
End Sub

Sub s3
   ? "Proc of Element 2"
End Sub

Sub s0
   ? "Proc of a Child"
End Sub

'=============================================================================='
