Extern "C++"

'=============================================================================='
Type _Tree As TreeType

Type TreeElementType
   Caption  As ZString  Ptr
   Procedur As Sub
   Child    As _Tree    Ptr
   Misc     As Any      Ptr
   
   ' Flags:
   Reduced  : 1 As Integer
   Disabled : 1 As Integer
End Type
'..............................................................................'
Type TreeType
   private:
      _count       As Integer                ' How many Elements (beginning at 1)
      _Elements    As TreeElementType   Ptr  ' all Elements, idx ranging form 0 to (count -1)
      _Parent      As TreeType          Ptr  ' owned by? Zero if top-Level
      _ParentIdx   As Integer                ' Child of Parent.Elements[ParentIdx]. Zero if top-Level
      _Level       As Integer                ' ammount of indents (child of child of child of ...)
      
   public:
      Declare Property caption            (idx As Integer)        As String
      Declare Property caption            (idx As Integer, newVal As String   )
      
      Declare Property Procedur           (idx As Integer)        As Sub
      Declare Property Procedur           (idx As Integer, newVal As Sub      )
      
      Declare Property Misc               (idx As Integer)        As Any Ptr
      Declare Property Misc               (idx As Integer, newVal As Any Ptr  )
      
      Declare Property Reduced            (idx As Integer)        As Integer
      Declare Property Reduced            (idx As Integer, newVal As Integer  )
      
      Declare Property Disabled           (idx As Integer)        As Integer
      Declare Property Disabled           (idx As Integer, newVal As Integer  )
      
      Declare Property Child              (idx As Integer)        As TreeType Ptr
      Declare Property Parent             (              )        As TreeType Ptr
      Declare Property ParentIdx          (              )        As Integer
      Declare Property ChildLevel         (              )        As Integer
      
      Declare Function CreateChildLevel   (idx As Integer)        As TreeType Ptr
      Declare Sub      DeleteChildLevel   (idx As Integer)
      
      Declare Property GetItemCount       (              )        As Integer
      
      
      Declare Sub AddItem                 (Element As TreeElementType, idx As Integer = 0)
      Declare Sub DelItem                 (                            idx As Integer = 0)
      
      
      Declare Destructor
End Type
'..............................................................................'
Type OutStruct
   caption  As String
   level    As Integer
   procedur As Sub
   Misc     As Any Ptr
   
   ' Flags:
   Reduced  : 1 As Integer
   Disabled : 1 As Integer
End Type

Declare Sub Struct2Array (Struct As TreeType Ptr, outArray() As OutStruct)
'..............................................................................'
Type StructElementDescriptor
   Group As TreeType Ptr
   idx   As Integer
End Type

Declare Function FindElmByIdx (Struct As TreeType Ptr, idx As Integer) As StructElementDescriptor
'=============================================================================='
Property TreeType.caption(index As Integer) As String
   If @This = 0                             Then Return ""
   If (index < 0) Or (index >= This._count) Then Return ""
   
   Return *This._Elements[index].caption
End Property
'..............................................................................'
Property TreeType.caption(index As Integer, value As String)
   Dim As Integer      i
   Dim As ZString Ptr tmp, old
   
   If @This = 0                            Then Return
   
   With This
      If (index < 0) Or (index >= ._count) Then Return
      
      old = ._Elements[index].caption
      tmp = ReAllocate( old, Len(value) + 1 )
      
      If tmp Then ._Elements[index].caption = tmp Else Return
      
      For i = 0 To Len(value) - 1
         ._Elements[index].caption[i] = value[i]
      Next
      ._Elements[index].caption[ Len(value) ] = 0
      
   End With
End Property
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::'
Property TreeType.Procedur(index As Integer) As Sub
   If @This = 0 Then Return 0
   If (index < 0) Or (index >= This._count) Then Return 0
   
   Return This._Elements[index].Procedur
End Property
'..............................................................................'
Property TreeType.Procedur(index As Integer, value As Sub)
   If @This = 0                             Then Return
   If (index < 0) Or (index >= This._count) Then Return
   
   This._Elements[index].Procedur = value
End Property
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::'
Property TreeType.Misc (index As Integer) As Any Ptr
   If  @This = 0                             Then Return 0
   If (index < 0) Or (index >= This._count)  Then Return 0
   
   Return This._Elements[index].Misc
End Property
'..............................................................................'
Property TreeType.Misc (index As Integer, newVal As Any Ptr)
   If  @This = 0                             Then Return
   If (index < 0) Or (index >= This._count)  Then Return
   
   This._Elements[index].Misc = newVal
End Property
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::'
Property TreeType.Reduced (index As Integer) As Integer
   '? "Reduced.Get"
   If  @This = 0                             Then Return 0
   If (index < 0) Or (index >= This._count)  Then Return 0
   
   Return This._Elements[index].Reduced
End Property
'..............................................................................'
Property TreeType.Reduced (index As Integer, newVal As Integer)
   If  @This = 0                             Then Return
   If (index < 0) Or (index >= This._count)  Then Return
   
   This._Elements[index].Reduced = newVal
End Property
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::'
Property TreeType.Disabled (index As Integer) As Integer
   If  @This = 0                             Then Return 0
   If (index < 0) Or (index >= This._count)  Then Return 0
   
   Return This._Elements[index].Disabled
End Property
'..............................................................................'
Property TreeType.Disabled (index As Integer, newVal As Integer)
   If  @This = 0                             Then Return
   If (index < 0) Or (index >= This._count)  Then Return
   
   This._Elements[index].Disabled = newVal
End Property
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::'
Property TreeType.Child (index As Integer) As TreeType Ptr
   If @This = 0 Then Return 0
   If (index < 0) Or (index >= This._count) Then Return 0
   
   Return This._Elements[index].Child
End Property
'..............................................................................'
Property TreeType.Parent () As TreeType Ptr
   If @This = 0 Then Return 0
   Return This._Parent
End Property
'..............................................................................'
Property TreeType.ParentIdx () As Integer
   If @This = 0 Then Return -1
   Return This._ParentIdx
End Property
'..............................................................................'
Property TreeType.ChildLevel () As Integer
   Return This._Level
End Property
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::'
Property TreeType.GetItemCount () As Integer
   If @This = 0 Then Return 0
   Return This._count
End Property
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::'
Function TreeType.CreateChildLevel (index As Integer) As TreeType Ptr
   Dim As TreeType Ptr NLT
   
   If @This = 0 Then Return 0

   ' Check if index is in 'array bound'
   If (index < 0) Or (index >= This._count) Then Return 0

   ' Check if a child already exists; return its adress if yes.
   If This._Elements[index].Child Then Return This._Elements[index].Child
   
   ' allocate space for a child
   This._Elements[index].Child = CAllocate( Len(TreeType) )
   If This._Elements[index].Child = 0 Then Exit Function

   ' Enter Data about Parent into new Child
   NLT = This._Elements[index].Child
   If NLT Then
      NLT->_Parent = @This
      NLT->_ParentIdx = index
      NLT->_Level = This._Level + 1
   End If

   Return This._Elements[index].Child
End Function
'..............................................................................'
Sub TreeType.DeleteChildLevel (index As Integer)
   If @This = 0 Then Return
   
   ' Delete Child using it's destructor:
   
   Scope
      Dim As TreeType x
      x = *This._Elements[index].Child
      ' ... and good bye...
   End Scope
   
   ' After that, delete the signs of the Child in Parent
   DeAllocate This._Elements[index].Child
              This._Elements[index].Child = 0
End Sub
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::'
Sub TreeType.AddItem(newVal As TreeElementType, index As Integer = 0)
   Dim As Integer i
   Dim As TreeElementType Ptr tmp

   If @This = 0 Then Return
   
   With This
      ' Check if idx is in specification
      ' Here, it is allowed to be equal to ._count, to enable placing an element to list's end.
      If  index = -1 Then index = ._count
      If (index <  0) Or (index > ._count) Then Return

      ' Alloc Space for new Adress of Element
      If ._Elements Then   ' If there are already elements:

         tmp = ReAllocate(._Elements, (._count + 1) * Len(TreeElementType) )
         If tmp Then      ._Elements = tmp Else Return


         ' Copy old adresses to new place, if they need to be moved.
         For i = ._count - 1 To index Step - 1
            ._Elements[i + 1] = ._Elements[i] 
         Next
         ._count += 1

      Else                 ' If this should be the first element created:
         ._Elements = CAllocate( Len(TreeElementType) )
         ._count = 1
      End If

      ' Copy newVal to _Elements[]
      With ._Elements[index]
         .Procedur = newVal.Procedur
         .Misc     = newVal.Misc
         .Child    = newVal.Child
         .Reduced  = newVal.Reduced
         .Disabled = newVal.Disabled
         
         i = Len(*newVal.caption) + 1
         .caption = CAllocate(i)
         For i = 0 To Len(*newVal.caption) - 1
            .caption[i]  = newVal.caption[i]
         Next
         .caption[ Len(*newVal.caption) ] = 0 : '?
      End With
   End With
End Sub
'..............................................................................'
Sub TreeType.DelItem(index As Integer = 0)
   Dim As Integer i
   Dim As TreeElementType Ptr tmp
   
   If @This = 0 Then Return
   
   With This
      If (index < 0) Or (index >= ._count) Then Return
      
      ' If this element has got a Child, delete it!
      If This._Elements[index].Child Then This.DeleteChildLevel(index)
      
      DeAllocate ._Elements[index].caption
      ' Do not DeAllocate .procedur! It might still be needed!
            
      ' Create temp buffer and copy Elements descriptor into it (w.o. element to be deleted!)
      tmp = CAllocate( (._count - 1) * Len(TreeElementType) )    ' size for [NumberOfElements - 1]
      For i = 0 To ._count - 1
         If     i  < index Then
            tmp[i] = ._Elements[i]
         ElseIf i  = index Then
            ' do nothing as THIS element should be deleted.
         Else
            tmp[i - 1] = ._Elements[i]
         End If
      Next
      
      ._count -= 1
      DeAllocate ._Elements
      ._Elements = tmp
   End With
End Sub
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::'
Destructor TreeType
   ' \========================================================/
   ' #                  scheme of work                        #
   ' /========================================================\
   '
   ' Element <------------------------------------------------+
   ' Got Childs?                                              |
   ' |         |                                              |
   ' +-> No.   +-> Yes. ---+                                  |
   '     |                 |                                  |
   '     +-> Delete        +------------------------> Follow -+
   '         |                                                |
   '         +-> Got a group member?                          |
   '             |         |                                  |
   '             +-> No.   +-> Yes. -----+                    |
   '                 |                   |                    |
   '                 +-> Got a Parent?   +----------> Follow -+
   '                     |         |                          |
   '                     +-> No.   +-> Yes. ------+           |
   '                         |                    |           |
   '                         +-> DTor complete.   +-> Follow -+
   

   Dim As Integer               Level
   Dim As Integer               maxBr, actBr, lstBr   ' maximum of branches (equal to ._count), actually analyzed branch
   Dim As TreeType Ptr actE , actParent      ' actual Element, actual Parent

   If @This = 0 Then Return
   
   If This._Elements = 0 Then Return

   actE = @This
   Level = 0

   NltDtorFindBranch:
      lstBr = actBr
      maxBr = actE->_count
      actBr = maxBr - 1
      actParent = actE->_Parent

      If maxBr = 0 Then
         actE  = actParent
         actBr = lstBr
         DeAllocate actE->_Elements[actBr].Child
         actE->_Elements[actBr].Child = 0
         Level -= 1
         Goto NltDtorFindBranch
      End If
      
   NltDtorFindChild:
      If actE->_Elements[actBr].Child Then
         actE = actE->_Elements[actBr].Child
         Level += 1
         Goto NltDtorFindBranch
      Else
         actE->DelItem(actBr)
      End If
      
   NltDtorFindMembers:
      If maxBr - 1 Then
         Goto NltDtorFindBranch
      End If
   
   NltDtorFindParent:
      If actParent Then
         Level -= 1
         actE = actParent
         If Level < 0 Then Return
         Goto NltDtorFindBranch
      End If
End Destructor
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::'
Sub Struct2Array (actE As TreeType Ptr, outArray() As OutStruct)
   ' \========================================================/
   ' #                  scheme of work                        #
   ' /========================================================\
   '
   ' Element <------------------------------------------------+
   ' |                                                        |
   ' +-> Print.                                               |
   ' |                                                        |
   ' +-> Got Childs?                                          |
   '     |         |                                          |
   '     +-> No.   +-> Yes. ----------+                       |
   '         |                        |                       |
   '         +-> Got Group Members?   +-------------> Follow -+
   '             |         |                                  |
   '             +-> No.   +-> Yes -----+                     |
   '                 |                  |                     |
   '                 +-> Got Parents?   +-----------> Follow -+
   '                     |         |                          |
   '                     +-> No.   +-> Yes. ------+           |
   '                         |                    |           |
   '                         +-> Printing Done.   +-> Follow -+
   

   Dim As Integer      Level, cnt       ' actual indent, count of group members
   Dim As Integer      amt = -1         ' ammount of entries (whole struct.)
   Dim As TreeType Ptr actChild         ' actual Child

   Level = 0
   Redim As Integer actBr(Level)
   
   DrwStcFindElm:
      amt += 1
      Redim Preserve As OutStruct outArray(amt)
      
      outArray(amt).level = actE->ChildLevel
      
      If actE->GetItemCount = 0 Then
         outArray(amt).caption   = "/emtpy element/"
         outArray(amt).procedur  = 0
         outArray(amt).misc      = 0
         outArray(amt).Reduced   = 0
         outArray(amt).Disabled  = 0
         Goto DrwStcFindParent
      Else
         outArray(amt).caption   = actE->Caption ( actBr(Level) )
         outArray(amt).procedur  = actE->Procedur( actBr(Level) )
         outArray(amt).misc      = actE->Misc    ( actBr(Level) )
         outArray(amt).Reduced   = actE->Reduced ( actBr(Level) )
         outArray(amt).Disabled  = actE->Disabled( actBr(Level) )
      End If
      
      

   DrwStcFindChild:
      If         actE->Reduced( actBr(Level) ) Then Goto DrwStcFindMember
      actChild = actE->Child  ( actBr(Level) )
      If actChild Then
         Level += 1
         Redim Preserve As Integer actBr(Level)
         actE = actChild
         Goto DrwStcFindElm
      End If
   
   DrwStcFindMember:
      cnt = (actE->GetItemCount)
      If cnt Then
         actBr(Level) += 1
         If actBr(Level) = cnt Then Goto DrwStcFindParent
         Goto DrwStcFindElm
      Else

         Goto DrwStcFindParent
      End If
      
   DrwStcFindParent:
      If Level Then
         Level -= 1
         actE = actE->Parent
         Redim Preserve As Integer actBr(Level)
         Goto DrwStcFindMember
      Else
         Goto DrwStcDone
      End If
      
   DrwStcDone:
   
End Sub
'..............................................................................'
Function FindElmByIdx (actE As TreeType Ptr, idx As Integer) As StructElementDescriptor
   ' \========================================================/
   ' #                  scheme of work                        #
   ' /========================================================\
   '
   ' Works just as 'Struct2Array'
   ' Does not output Data into an Array, but returns Descriptor
   ' of Element #idx of Structure.
   

   Dim As Integer                       Level, cnt              ' actual indent, count of group members
   Dim As Integer                       amt = -1                ' ammount of entries (whole struct.)
   Dim As TreeType Ptr                  actChild                ' actual Child
   Dim As StructElementDescriptor tmpDesc                 ' temporary Element to be put out

   Level = 0
   Redim As Integer actBr(Level)
   
   FindElmFindElm:
      amt += 1
      If amt = idx Then
         tmpDesc.Group = actE
         tmpDesc.idx   = actBr(Level)
         Function = tmpDesc
         Goto FindElmDone
      End If
      If actE->GetItemCount = 0 Then Goto FindElmFindParent
            
   
   FindElmFindChild:
      If         actE->Reduced( actBr(Level) ) Then Goto FindElmFindMember
      actChild = actE->Child  ( actBr(Level) )
      If actChild Then
         Level += 1
         Redim Preserve As Integer actBr(Level)
         actE = actChild
         Goto FindElmFindElm
      End If
   
   FindElmFindMember:
      cnt = (actE->GetItemCount)
      If cnt Then
         actBr(Level) += 1
         If actBr(Level) = cnt Then Goto FindElmFindParent
         Goto FindElmFindElm
      Else

         Goto FindElmFindParent
      End If
      
   FindElmFindParent:
      If Level Then
         Level -= 1
         actE = actE->Parent
         Redim Preserve As Integer actBr(Level)
         Goto FindElmFindMember
      Else
         Goto FindElmDone
      End If
      
   FindElmDone:
   
End Function
'============================================================================='

End Extern
