/'

################################################################################
#                                                                              #
#            M A N A G E M E N U   -   T R E E   S T R U C T U R E S           #
#                           I N   F R E E   B A S I C                          #
#                                                                              #
################################################################################


ManageMenu is an open-source-Project by Stefan Hartinger alias Dusky_Joe
contact: stefan_hartinger@gmx.de
Designed for freeBASIC v0.17s
Compile-Date: 2007-07-13

feel free to use.

ManageMenu enables you to easily create complex tree structures of any count of levels.
For an example of usage, see "ManageMenu example.bas", which should be included in this archive.
For an detailled documentation, see "Doku ManageMenu DE.txt" (german)

'/


Extern "C++" Lib "ManageMenu"

   Type _Tree As TreeType
   
   Type TreeElementType
      Caption  As ZString  Ptr
      Procedur As Sub
      Child    As _Tree    Ptr
      Misc     As Any      Ptr
      
      ' Flags:
      Reduced  : 1 As Integer
      Disabled : 1 As Integer
   End Type
'..............................................................................'
   Type TreeType
      private:
         _count       As Integer                ' How many Elements (beginning at 1)
         _Elements    As TreeElementType   Ptr  ' all Elements, idx ranging form 0 to (count -1)
         _Parent      As TreeType          Ptr  ' owned by? Zero if top-Level
         _ParentIdx   As Integer                ' Child of Parent.Elements[ParentIdx]. Zero if top-Level
         _Level       As Integer                ' ammount of indents (child of child of child of ...)
         
      public:
         Declare Property caption            (idx As Integer)        As String
         Declare Property caption            (idx As Integer, newVal As String   )
         
         Declare Property Procedur           (idx As Integer)        As Sub
         Declare Property Procedur           (idx As Integer, newVal As Sub      )
         
         Declare Property Misc               (idx As Integer)        As Any Ptr
         Declare Property Misc               (idx As Integer, newVal As Any Ptr  )
         
         Declare Property Reduced            (idx As Integer)        As Integer
         Declare Property Reduced            (idx As Integer, newVal As Integer  )
         
         Declare Property Disabled           (idx As Integer)        As Integer
         Declare Property Disabled           (idx As Integer, newVal As Integer  )
         
         Declare Property Child              (idx As Integer)        As TreeType Ptr
         Declare Property Parent             (              )        As TreeType Ptr
         Declare Property ParentIdx          (              )        As Integer
         Declare Property ChildLevel         (              )        As Integer
         
         Declare Function CreateChildLevel   (idx As Integer)        As TreeType Ptr
         Declare Sub      DeleteChildLevel   (idx As Integer)
         
         Declare Property GetItemCount       (              )        As Integer
         
         
         Declare Sub AddItem                 (Element As TreeElementType, idx As Integer = 0)
         Declare Sub DelItem                 (                            idx As Integer = 0)
         

         Declare Destructor
   End Type
'..............................................................................'
   Type OutStruct
      caption  As String
      level    As Integer
      procedur As Sub
      Misc     As Any Ptr
      
      ' Flags:
      Reduced  : 1 As Integer
      Disabled : 1 As Integer
   End Type
   
   Declare Sub Struct2Array (Struct As TreeType Ptr, outArray() As OutStruct)
'..............................................................................'
   Type StructElementDescriptor
      Group As TreeType Ptr
      idx   As Integer
   End Type
   
   Declare Function FindElmByIdx (Struct As TreeType Ptr, idx As Integer) As StructElementDescriptor

End Extern
